@echo off & setlocal enableextensions enabledelayedexpansion
echo.+----------------------------------------------------+
echo ^| EDATE.CMD to display some alternative date formats ^|
echo ^| By Prof. Timo Salmi, Last modified Sun 1-May-2005  ^|
echo +----------------------------------------------------+
echo.
::
:: Requires G(nu)AWK
:: Test for its availability at path or in the current folder
for %%f in ("GAWK.EXE") do set found_=%%~$PATH:f
if exist GAWK.EXE set found_=GAWK.EXE
if [%found_%]==[] (
  echo GAWK.EXE needed by the script not available
  if not [%cmdbox%]==[true] if [%PauseIfFromDesktop%]==[true] pause
  goto :EOF)
::
:: Winter (normal) and summertime offsets
set winter_=+0200
set summer_=+0300
::
:: Use codepage 850 to fix the date format
for /f "tokens=3 delims= " %%p in (
  'mode con: codepage /status ^| find "Code page"') do (
  set store_codepage_=%%p)
mode con: codepage select=850>nul
::
:: Display some alternative date/time presentations
if [%date:~8,1%]==[0] gawk 'BEGIN{printf"6%%s\n",substr(strftime("%%y%%m%%d"),2,5)}'
if [%date:~8,1%]==[1] gawk 'BEGIN{printf"7%%s\n",substr(strftime("%%y%%m%%d"),2,5)}'
gawk 'BEGIN{printf"%%s\n",strftime("%%Y.%%m.%%d")}'
echo.
gawk 'BEGIN{printf"%%s\n",strftime("%%a %%b %%d %%H:%%M:%%S %%Y")}'
gawk 'BEGIN{printf"%%s %winter_% (EET)\n",strftime("%%a, %%d %%b %%Y %%H:%%M:%%S")}'
gawk 'BEGIN{printf"%%s %summer_% (EEST)\n",strftime("%%a, %%d %%b %%Y %%H:%%M:%%S")}'
echo.
gawk 'BEGIN{printf"%%s\n",strftime("%%a %%b %%d %%H:%%M:%%S %%Y Week %%V Day %%j")}'
gawk 'BEGIN{printf"%%s\n",strftime("%%A %%d %%B %%Y %%H:%%M:%%S")}'
gawk 'BEGIN{printf"%%s\n",strftime("%%a %%d-%%b-%%Y %%H:%%M")}'
gawk 'BEGIN{printf"%%s\n",strftime("%%a %%d-%%b-%%Y %%H:%%M:%%S")}'
:: Drop the leading zero from a 01-09 day
if [%date:~0,1%]==[0] gawk 'BEGIN{printf"%%s %%s\n",strftime("%%a"),substr(strftime("%%d-%%b-%%Y %%H:%%M:%%S"),2)}'
echo.
::
:: Local date presentations (here in Finnish, customize as appropriate)
gawk 'BEGIN{printf"@set wdnum_=%%s\n",strftime("%%w")}'>%temp%\tmp$$$.cmd
for %%c in (call del) do %%c %temp%\tmp$$$.cmd
set WeekdayArray=SuMaTiKeToPeLa
set /a i_=2*%wdnum_%
set weekday_=!WeekdayArray:~%i_%,2!
echo %weekday_% %date:~0,2%.%date:~3,2%.%date:~6,4% %time:~0,8%
::
if "%wdnum_%"=="0" set weekday_=sunnuntai
if "%wdnum_%"=="1" set weekday_=maanantai
if "%wdnum_%"=="2" set weekday_=tiistai
if "%wdnum_%"=="3" set weekday_=keskiviikko
if "%wdnum_%"=="4" set weekday_=torstai
if "%wdnum_%"=="5" set weekday_=perjantai
if "%wdnum_%"=="6" set weekday_=lauantai
set monthNum=%date:~3,2%
if "%monthNum%"=="01" set month_=tammi
if "%monthNum%"=="02" set month_=helmi
if "%monthNum%"=="03" set month_=maalis
if "%monthNum%"=="04" set month_=huhti
if "%monthNum%"=="05" set month_=touko
if "%monthNum%"=="06" set month_=kes
if "%monthNum%"=="07" set month_=hein
if "%monthNum%"=="08" set month_=elo
if "%monthNum%"=="09" set month_=syys
if "%monthNum%"=="10" set month_=loka
if "%monthNum%"=="11" set month_=marras
if "%monthNum%"=="12" set month_=joulu
echo %weekday_% %date:~0,2%. %month_%kuuta %date:~6,4% %time:~0,8%
echo %weekday_%na %date:~0,2%. %month_%kuuta %date:~6,4% %time:~0,8%
::
:: Clean up
mode con: codepage select=%store_codepage_%>nul
if not [%cmdbox%]==[true] if [%PauseIfFromDesktop%]==[true] pause
endlocal & goto :EOF
